#include "stdafx.h"
#include "common\my_include.h"
#include "prim.h"
#include "render.h"

//void ToneMapping( CColor *pDest, CColor *pSrc, u32 nPixels );

namespace Render {

D3DXVECTOR3 BG_COLOR = D3DXVECTOR3(0.25f, 0.4f, 0.5f);

extern OBJ_DATA sphere_data[];
extern OBJ_DATA room_data[];
extern OBJ_DATA Short_block[];
extern OBJ_DATA Tall_block[];

OBJ_DATA *pLightPolygone[2];

typedef struct
{
	OBJ_DATA    *pObjData; // _f[^
	D3DXVECTOR3  normal;   // @
	float        area;     // ʐ
}LIGHT_DATA;

class CCamera
{
private:
	D3DXVECTOR3 m_vFrom;
	D3DXVECTOR3 m_vLookat;
	D3DXVECTOR3 m_vUp;

	float   m_fFilmSize[2];  // tB̎0.036*0.024[m*m]0.025*0.025(Cornell Box)
	float   m_fFocalLength;  // œ_ 0.035(Cornell Box )
	float   m_fFNumber;      // Fl
	float   m_fFocusDistance;// sgʒu܂ł̋

	float   m_fLensRadius;   // Y̔a(f/2F)
	float   m_fFilmDistance; // tB܂ł̋ Lf/(L-f)

	D3DXVECTOR3 u, v, w;

public:

	void Update();
	void SetFrom  (const D3DXVECTOR3 *p){m_vFrom  =*p;}
	void SetLookAt(const D3DXVECTOR3 *p){m_vLookat=*p;}
	void SetUp    (const D3DXVECTOR3 *p){m_vUp    =*p;}
	void SetFilmSize      (float w, float h){m_fFilmSize[0] = w; m_fFilmSize[1] = h;}
	void SetFocalLength   (float v){m_fFocalLength   = v;}
	void SetFNumber       (float v){m_fFNumber       = v;}
	void SetFocusDistance (float v){m_fFocusDistance = v;}
	
	void GetRay( D3DXVECTOR3 *o, D3DXVECTOR3 *v, float x, float y);
};

// ---------------------------------------------------------------------------
// IuWFNg
// ---------------------------------------------------------------------------
char   s_data [4*RENDER_WIDTH*RENDER_HEIGHT];// zt[obt@
float  s_total[4*RENDER_WIDTH*RENDER_HEIGHT];// ݐσt[obt@
CColor s_tmp  [  RENDER_WIDTH*RENDER_HEIGHT];// ꎞt[obt@

CCamera camera;

CRand   *g_pRand = NULL;
#define frand() ((float)g_pRand->GetF32())

CMesh *pRoom       = NULL;
CMesh *pBlockSmall = NULL;
CMesh *pBlockTall  = NULL;
CMesh *pShpereS    = NULL;
CMesh *pShpereT    = NULL;
#define LIGHT_DATA_MAX 2
LIGHT_DATA g_LightData[LIGHT_DATA_MAX];
float      g_fTotalArea;

static int s_x = 0;			// _OsNẐW
static int s_y = 0;			// _OsNẐW
static float render_cnt = 0;// `
enum{
	STATE_IDLE=0,			// ҂
	STATE_RENDER_BEGIN,		// 
	STATE_RENDER,			// `
	STATE_RENDER_END,		// Еt
};

// ---------------------------------------------------------------------------
// ֐錾
// ---------------------------------------------------------------------------
D3DXVECTOR3 *GetColor(D3DXVECTOR3 *dest, float x, float y);

// ---------------------------------------------------------------------------
// Ǘ
// ---------------------------------------------------------------------------
// ̂P_I
LIGHT_DATA *choiceEmmisivePoint( D3DXVECTOR4 *pos, D3DXVECTOR3 *dir )
{
	LIGHT_DATA *pData;
	float a = g_fTotalArea * g_pRand->GetF32();

	pData = &g_LightData[0];
	for( int i = 0; i < LIGHT_DATA_MAX; i++ )
	{
		if( a < pData->area )
		{
			// 3p`̓̂P_I
			float s = g_pRand->GetF32();
			float t = g_pRand->GetF32();
			if(1 < s + t) {s=1-s;t=1-t;}

			float *x0 = pData->pObjData->triangle.x0;
			float *x1 = pData->pObjData->triangle.x1;
			float *x2 = pData->pObjData->triangle.x2;
			pos->x = (1.0f-s-t)*x0[0] + s * x1[0] + t * x2[0];
			pos->y = (1.0f-s-t)*x0[1] + s * x1[1] + t * x2[1];
			pos->z = (1.0f-s-t)*x0[2] + s * x1[2] + t * x2[2];
			pos->w = 1.0f;

			*dir = pData->normal;
			return pData;
		}
		a -= pData->area;
		pData++;
	}
	return NULL;
}

// ---------------------------------------------------------------------------
// JNX
// ---------------------------------------------------------------------------
void CCamera::Update()
{
	// KšvZ
	D3DXVec3Subtract( &w, &m_vLookat, &m_vFrom );
	D3DXVec3Cross( &v, &w, &m_vUp );
	D3DXVec3Cross( &u, &v, &w );
	D3DXVec3Normalize( &u, &u );
	D3DXVec3Normalize( &v, &v );
	D3DXVec3Normalize( &w, &w );

	// Y̔a(f/2F)
	m_fLensRadius = 0.5f * m_fFocalLength / m_fFNumber;
	// tB܂ł̋ Lf/(L-f)
	m_fFilmDistance = m_fFocusDistance*m_fFocalLength/(m_fFocusDistance-m_fFocalLength);
}
// ---------------------------------------------------------------------------
void CCamera::GetRay( D3DXVECTOR3 *o, D3DXVECTOR3 *dir, float x, float y)
{
	D3DXVECTOR3 ds, e;
	D3DXVECTOR3 tmp, tmp1;
	float z1 = frand();
	float z2 = frand();

	float r = m_fLensRadius * sqrtf(z1);
	float theta = 2.0f * D3DX_PI * z2;
	
	// C΂ʒu
	D3DXVec3Scale( &tmp, &v, cosf(theta) );
	D3DXVec3Scale( &ds,  &u, cosf(theta) );
	D3DXVec3Add( &ds, &ds, &tmp );
	D3DXVec3Scale( &ds, &ds, r );
	D3DXVec3Add( o, &ds, &m_vFrom );

	// Y̒Ssg̓ʒuւ̃xNg
	D3DXVec3Scale( &e,    &w,   m_fFilmDistance );
	D3DXVec3Scale( &tmp,  &v,   m_fFilmSize[0] * (x-0.5f) );
	D3DXVec3Scale( &tmp1, &u, - m_fFilmSize[1] * (y-0.5f) );
	D3DXVec3Add( &e, &e, &tmp );
	D3DXVec3Add( &e, &e, &tmp1 );
	D3DXVec3Normalize( &e, &e );

	D3DXVec3Scale( dir, &e, m_fFocusDistance / D3DXVec3Dot( &e, &w ) );
	D3DXVec3Subtract( dir, dir, &ds );
	D3DXVec3Normalize( dir, dir );
}


// ---------------------------------------------------------------------------
// Xbh
// ---------------------------------------------------------------------------

MySystem::CThreadMgr *g_pThreadMgr = NULL;

unsigned int WINAPI workthread ( LPVOID pParam )
{
	MySystem::CThreadMgr  *pSender = (MySystem::CThreadMgr *)pParam;
	MySystem::CThreadData *ptr;
	
	while( pSender->IsEnable() )
	{
		while( NULL != (ptr = pSender->GetWork()) )
		{
			// --- Xbhf[^Ƃ̏

			rect *pRect = (rect *)ptr->GetData();

			for( s32 y = pRect->top; y < pRect->bottom; y++ )
			{
				for( s32 x = pRect->left; x < pRect->right; x++ )
				{
					D3DXVECTOR3 col;

					GetColor(&col, ((float)x+0.5f)/(float)RENDER_WIDTH
								 , ((float)y+0.5f)/(float)RENDER_HEIGHT);
					int no = 4*(y*RENDER_WIDTH+x);
					s_total[no+0]+=col.x;// R
					s_total[no+1]+=col.y;// G
					s_total[no+2]+=col.z;// B
				}
			}

			// --- ܂ŃXbhf[^Ƃ̏

			// IÃXbhf[^E
			ptr->Finish( );
		}
		Sleep(10);
	}

    return 0;
}


// ---------------------------------------------------------------------------
char *GetDataPointer()
{
	return s_data;
}
// ---------------------------------------------------------------------------
int GetRenderCount()
{
	return (int)(render_cnt+0.5f);
}
// ---------------------------------------------------------------------------
void Init()
{
	int i, j;

	camera.SetFrom  (&D3DXVECTOR3(278,273,-800));
	camera.SetLookAt(&D3DXVECTOR3(278,273,0));
	camera.SetUp    (&D3DXVECTOR3(0,1,0));
	camera.SetFilmSize      ( ASPECT*25, 25 );
	camera.SetFocalLength   ( 35 );
	camera.SetFNumber       ( 0.3f  );
	camera.SetFocusDistance ( 1100.0 );
	camera.Update();
	
	g_pRand = new CRand();

	pRoom = new CMesh();
	pRoom->Init( room_data, 14 );
	
	pBlockSmall = new CMesh();
	pBlockSmall->Init( Short_block, 10);

	pBlockTall = new CMesh();
	pBlockTall->Init( Tall_block, 10);
	
	pShpereS = new CMesh();
	pShpereS->Init( sphere_data, 1);
	
	pShpereT = new CMesh();
	pShpereT->Init( sphere_data+1,1);

	// Cg
	g_LightData[0].pObjData = &room_data[0];
	g_LightData[1].pObjData = &room_data[1];
	g_fTotalArea = 0.0f;
	for( i = 0; i < LIGHT_DATA_MAX; i++ )
	{
		float *x0, *x1, *x2;
		g_LightData[i].normal   = D3DXVECTOR3(0,-1,0);// Cg
		x0 = g_LightData[i].pObjData->triangle.x0;
		x1 = g_LightData[i].pObjData->triangle.x1;
		x2 = g_LightData[i].pObjData->triangle.x2;
		g_LightData[i].area = 0.5f * fabs((x1[0]-x0[0])*(x2[2]-x0[2])-(x2[0]-x0[0])*(x1[2]-x0[2]));
		g_fTotalArea += g_LightData[i].area;
	}

	// t[obt@̏
	render_cnt = 0; // _O
	for(j=0; j<RENDER_HEIGHT; j++){
	for(i=0; i<RENDER_WIDTH ; i++){
		s_data [4*(j*RENDER_WIDTH+i)+0]=(char)255;// R
		s_data [4*(j*RENDER_WIDTH+i)+1]=(char)(i*256/RENDER_WIDTH );// G
		s_data [4*(j*RENDER_WIDTH+i)+2]=(char)(j*256/RENDER_HEIGHT);// B
		s_total[4*(j*RENDER_WIDTH+i)+0]=0;// R
		s_total[4*(j*RENDER_WIDTH+i)+1]=0;// G
		s_total[4*(j*RENDER_WIDTH+i)+2]=0;// B
	}
	}

	// Xbh𓮂
	g_pThreadMgr = new MySystem::CThreadMgr( workthread
											, 2  // őXbhiCPU̐Ɠxj
											, 16 // Xbhɗ߂d̐
											);
}

// ---------------------------------------------------------------------------
void Delete()
{
	// XbhI
	if(g_pThreadMgr) delete g_pThreadMgr;g_pThreadMgr=NULL;

	if(pShpereT){delete pShpereT;pShpereT=NULL;}
	if(pShpereS){delete pShpereS;pShpereS=NULL;}
	if(pBlockTall){delete pBlockTall;pBlockTall=NULL;}
	if(pBlockSmall){delete pBlockSmall;pBlockSmall=NULL;}
	if(pRoom){delete pRoom; pRoom=NULL;}
	if(g_pRand){delete g_pRand; g_pRand=NULL;}
}
// ---------------------------------------------------------------------------

#define BLOCK_X 2
#define BLOCK_Y 2
#define RENDERING_COUNT 1


// ---------------------------------------------------------------------------
int Render()
{
	int k,no;
	static unsigned int save_bit = 0;

	render_cnt+=RENDERING_COUNT;

#if 0
	for(int i=0;i<RENDERING_COUNT;i++)
	{
		for( s32 y = 0; y < RENDER_HEIGHT; y++ )
		{
			for( s32 x = 0; x < RENDER_WIDTH; x++ )
			{
				auto D3DXVECTOR3 col;

				GetColor(&col, ((float)x+0.5f)/(float)RENDER_WIDTH
							 , ((float)y+0.5f)/(float)RENDER_HEIGHT);
				int no = 4*(y*RENDER_WIDTH+x);
				s_total[no+0]+=col.x;// R
				s_total[no+1]+=col.y;// G
				s_total[no+2]+=col.z;// B
			}
		}
	}
#else
	static rect r[BLOCK_Y][BLOCK_X];
	
	for( s32 i = 0; i < BLOCK_Y; i++ )
	{
		for( s32 j = 0; j < BLOCK_X; j++ )
		{
			r[i][j].left   = (j+0)*RENDER_WIDTH /BLOCK_X;
			r[i][j].right  = (j+1)*RENDER_WIDTH /BLOCK_X;
			r[i][j].top    = (i+0)*RENDER_HEIGHT/BLOCK_Y;
			r[i][j].bottom = (i+1)*RENDER_HEIGHT/BLOCK_Y;
		}
	}
	
	// `
	for( int n = 0; n < RENDERING_COUNT; n++)
	{
		for( s32 i = 0; i < BLOCK_Y; i++ )
		{
			for( s32 j = 0; j < BLOCK_X; j++ )
			{
				g_pThreadMgr->Req( &r[i][j] );
			}
		}
		while( 0 != g_pThreadMgr->GetLeftWork() )Sleep(10);
	}
	
#endif

	
	// g[}bsO
	no = 0;
	for(s32 j=0; j<RENDER_HEIGHT; j++){
	for(s32 i=0; i<RENDER_WIDTH ; i++){
		s_tmp[no].r = max(0,s_total[4*no+0]/render_cnt);
		s_tmp[no].g = max(0,s_total[4*no+1]/render_cnt);
		s_tmp[no].b = max(0,s_total[4*no+2]/render_cnt);
		no++;
	}
	}

//	ToneMapping( s_tmp, s_tmp, RENDER_WIDTH*RENDER_HEIGHT );

	// ʂ̔f
	no = 0;
	for(s32 j=0; j<RENDER_HEIGHT; j++){
	for(s32 i=0; i<RENDER_WIDTH ; i++){
		auto CColor &c = s_tmp[no>>2];
		s_data [no+0]=(unsigned char)(255.9*max(0,min(1,c.r)));// R
		s_data [no+1]=(unsigned char)(255.9*max(0,min(1,c.g)));// G
		s_data [no+2]=(unsigned char)(255.9*max(0,min(1,c.b)));// B
		no += 4;
	}
	}

	// KȂƂɉ摜ۑ
	if( (1<<save_bit) <= GetRenderCount() )
	{
		// t@C߂
		_TCHAR buf[256];
		_stprintf( buf, _T("%d.bmp"), GetRenderCount());
		
		// rbg}bvC[W
		BYTE *pImage = new BYTE[3 * RENDER_WIDTH * RENDER_HEIGHT];
		k = 0;
		for(s32 j=0; j<RENDER_HEIGHT; j++)
		{
			no = 4*RENDER_WIDTH*(RENDER_HEIGHT-j-1);
			for(s32 i=0; i<RENDER_WIDTH ; i++)
			{
				pImage[k+0] = s_data [no+2];
				pImage[k+1] = s_data [no+1];
				pImage[k+2] = s_data [no+0];
				no += 4;
				k += 3;
			}
		}

		// rbg}bvɕKvȏi[
		SAVE_BITMAP tBitmap_Info;
		tBitmap_Info.pFileName = buf;
		tBitmap_Info.iWidth  = RENDER_WIDTH;
		tBitmap_Info.iHeight = RENDER_HEIGHT;
		tBitmap_Info.iBitCount = 24;
		tBitmap_Info.pData = (BYTE*)pImage;

		SaveBitMap( tBitmap_Info );

		delete[] pImage;

		save_bit++;
	}

	return 0;
}

// ---------------------------------------------------------------------------
#define GETCOLOR_FLAG_DISABLE_EMMISIVE (1<<0)

bool GetColor( D3DXVECTOR3 *dest, const D3DXVECTOR4 *x, const D3DXVECTOR4 *v, int depth, u32 flag )
{
	D3DXVECTOR3 diffuse_color=D3DXVECTOR3(0,0,0);

	// -----------------------------------------------------------------------
	// F܁A˂ȂŉXƒ˕ԂƂ́A͂ȂF
	// -----------------------------------------------------------------------
	if(0==depth) *dest = D3DXVECTOR3(0,0,0);

	// -----------------------------------------------------------------------
	// ċAꍇ͌͂ĂȂ̂ƍl
	// -----------------------------------------------------------------------
	const int DEPTH_MAX = 3;
	if(DEPTH_MAX <= depth) { *dest=D3DXVECTOR3(0,0,0); return FALSE;}

	// -----------------------------------------------------------------------
	// _߂
	// -----------------------------------------------------------------------
	float t = CPrimitive::INFINTY_DIST;
	CPrimitive *pObj = NULL;
	D3DXVECTOR4 p, n;// _̈ʒuƖ@

	t = pShpereS   ->IsAcross(t, &n, &p, &pObj, x, v);
	t = pShpereT   ->IsAcross(t, &n, &p, &pObj, x, v);
	t = pRoom      ->IsAcross(t, &n, &p, &pObj, x, v);
//	t = pBlockSmall->IsAcross(t, &n, &p, &pObj, x, v);
	t = pBlockTall ->IsAcross(t, &n, &p, &pObj, x, v);

	if( NULL == pObj ){
		// ̓IuWFNgOꂽI
		*dest = BG_COLOR;
		return TRUE;
	}

	// -----------------------------------------------------------------------
	// ˕VA[bgŌ߂
	// -----------------------------------------------------------------------
	float cd = pObj->m_material.diffuse;	// gU
	float cr = pObj->m_material.reflection;	// ˗
	float cn = pObj->m_material.refraction;	// ܗ
	float ce = pObj->m_material.emmisive;	// ˗
	float total = cd+cr+cn+ce;
	float prob = total * (float)frand();

	int type = 0;// gU
	if(prob < cr      ) type = 1; else// 
	if(prob < cr+cn   ) type = 2; else// 
	if(prob < cr+cn+ce) type = 3;     // 

	// -----------------------------------------------------------------------
	// _AeɉBĂ邩ǂׂāAgUZo
	// -----------------------------------------------------------------------
	if(0==type)
	{
		if(++depth<DEPTH_MAX)
		{
			D3DXVECTOR4 dir, pos;

			// --- ̉elɓ
			D3DXVECTOR4 lp;
			D3DXVECTOR3 ln;
			// P_I
			LIGHT_DATA *pData = choiceEmmisivePoint( &lp, &ln );
			D3DXVECTOR4 vr = lp-p; vr.w = 0;
			float d2 = D3DXVec3Dot((D3DXVECTOR3 *)&vr,(D3DXVECTOR3 *)&vr); // ˓_܂ł̋̂Q
			D3DXVec4Normalize(&vr, &vr);     // ˓_

			// ̓_邩ǂׂ
			CPrimitive *pTObj = NULL;
			D3DXVECTOR4 tp, tn;// _̈ʒuƖ@
			float tt = CPrimitive::INFINTY_DIST;
			pos = p + 0.01f*(vr);
			tt = pShpereS   ->IsAcross( tt, &tn, &tp, &pTObj, &pos, &vr );
			tt = pShpereT   ->IsAcross( tt, &tn, &tp, &pTObj, &pos, &vr );
			tt = pRoom      ->IsAcross( tt, &tn, &tp, &pTObj, &pos, &vr );
//			tt = pBlockSmall->IsAcross( tt, &tn, &tp, &pTObj, &pos, &vr );
			tt = pBlockTall ->IsAcross( tt, &tn, &tp, &pTObj, &pos, &vr );
			
			if( pTObj && 1.0f == pTObj->m_material.emmisive )
			{
				// ڌƊԐڌ̋̊ʐςŋ߂
				float prob;
				prob = -g_fTotalArea * D3DXVec3Dot((D3DXVECTOR3 *)&vr, (D3DXVECTOR3 *)&ln)/d2;
				prob /= 2.0f*D3DX_PI;// ͂񂾂Ƃ̗̊p2sr
				if(prob<0)prob=0;
				if(1<prob)prob=1;

				float rn = D3DXVec3Dot((D3DXVECTOR3 *)&vr, (D3DXVECTOR3 *)&n);
				rn = max( 0, rn );
				diffuse_color.x = prob * pTObj->m_material.COLOR_DIF[0] * rn;
				diffuse_color.y = prob * pTObj->m_material.COLOR_DIF[1] * rn;
				diffuse_color.z = prob * pTObj->m_material.COLOR_DIF[2] * rn;
			}
			
			// --- VA[bgŕʂ̃C΂
			
			// IɃC΂
			float theta =      D3DX_PI * (float)frand();
			float phi   = 2.0f*D3DX_PI * (float)frand();
			dir.x = sinf(theta) * cosf(phi);
			dir.y = sinf(theta) * sinf(phi);
			dir.z = cosf(theta);
			float dn = D3DXVec3Dot((D3DXVECTOR3 *)&dir, (D3DXVECTOR3 *)&n);
			if(dn<0){
				// @ƔΌɔԂȂA𔽑΂ɂ
				dn = -dn;
				dir.x *= -1;
				dir.y *= -1;
				dir.z *= -1;
			}

			D3DXVECTOR3 c;
			pos = p + 0.01f*(dir);
			GetColor( &c, &pos, &dir, depth, GETCOLOR_FLAG_DISABLE_EMMISIVE );
			// v~eBu̐FgU̗]Kp
			diffuse_color.x += c.x * dn;
			diffuse_color.y += c.y * dn;
			diffuse_color.z += c.z * dn;

			diffuse_color.x *= pObj->m_material.COLOR_DIF[0] * 0.5f*D3DX_PI;
			diffuse_color.y *= pObj->m_material.COLOR_DIF[1] * 0.5f*D3DX_PI;
			diffuse_color.z *= pObj->m_material.COLOR_DIF[2] * 0.5f*D3DX_PI;
		}
	}

	// -----------------------------------------------------------------------
	// ċAIɌ΂āA荂̔˂lɓ
	// -----------------------------------------------------------------------
	// 
	D3DXVECTOR3 reflect_color=D3DXVECTOR3(0,0,0);
	if(1==type){
		// ˃xNg
		D3DXVECTOR4 r = *v - 2.0f*D3DXVec3Dot((D3DXVECTOR3 *)&n, (D3DXVECTOR3 *)v) * n;
		D3DXVECTOR4 pos = p + 0.01f*n;// ƕ
		if(!GetColor( &reflect_color, &pos, &r, depth,0)){
			cr = 0;// ǁA͂Ȃ
		}
	}

	// -----------------------------------------------------------------------
	// 
	// -----------------------------------------------------------------------
	D3DXVECTOR3 refract_color=D3DXVECTOR3(0,0,0);
	if(2==type){
		// ܃xNg
		D3DXVECTOR4 t, pos;
		float VN = D3DXVec3Dot((D3DXVECTOR3 *)v, (D3DXVECTOR3 *)&n);
		float eta = 1.5f;
		if(VN<0){
			// 
			float D = 1-(1+VN)*(1+VN)/(eta*eta);
			if(D<0){cn=0;goto no_refract;}// S
			t = (-VN/eta-sqrtf(D))*n+(1/eta)*(*v);
			pos = p - 0.01f*n;// ƕ
		}else{
			// očs
			float D = 1-(1-VN)*(1-VN)*(eta*eta);
			if(D<0){cn=0;goto no_refract;}// S
			t = -(VN*eta-sqrtf(D))*n+eta*(*v);
			pos = p + 0.01f*n;// ƕ
		}
		D3DXVec3Normalize( (D3DXVECTOR3 *)&t, (D3DXVECTOR3 *)&t );
		if(!GetColor( &refract_color, &pos, &t, depth,0)){
			cn = 0;// ǁA͂Ȃ
		}
	}
no_refract:

	// -----------------------------------------------------------------------
	// 
	// -----------------------------------------------------------------------
	D3DXVECTOR3 emmisive_color;
	if(flag & GETCOLOR_FLAG_DISABLE_EMMISIVE)
	{
		emmisive_color = D3DXVECTOR3(0,0,0);
	}else{
		emmisive_color = *(D3DXVECTOR3*)&pObj->m_material.COLOR_DIF;
	}

	// -----------------------------------------------------------------------
	// Fo͂
	// -----------------------------------------------------------------------
	switch(type){
	case 0:// gU
		*dest = (cd+cr+cn) * diffuse_color;
		break;
	case 1:// 
		*dest = (cd+cr+cn) * reflect_color;		
		break;
	case 2:// 
		*dest = (cd+cr+cn) * refract_color;
		break;
	case 3:// 
		*dest = ce * emmisive_color;
		break;
	}

	return TRUE;
}
// ---------------------------------------------------------------------------
D3DXVECTOR3 *GetColor(D3DXVECTOR3 *dest, float x, float y)
{
	D3DXVECTOR4 ray_start;
	D3DXVECTOR4 ray_dir;
	
	ray_start.w = 1.0f;
	ray_dir.w   = 0.0f;

	camera.GetRay( (D3DXVECTOR3*)&ray_start, (D3DXVECTOR3*)&ray_dir, x, y);
	
	GetColor(dest, &ray_start, &ray_dir, 0,0);

	return dest;
}

};// namespace Render
